/*-*-linux-c-*-*/

/*
 *  gnewtellium - Newtella for Unix
 *  Copyright (C) 2001 Elias Athanasopoulos
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef GLOBAL_H
#define GLOBAL_H

#include "../config.h"

#include <gtk/gtk.h>

#include "guid.h"

#define MAX_TEMPBUF_LEN 4096

#define GNUTELLA_MAX_HOPS               7
#define GNUTELLA_MAX_TTL                50
#define GNUTELLA_MAX_QUERY              128
#define GNUTELLA_MAX_QUERYRESPONSE      67075
#define MAX_PACKET_LENGTH               67075

#define INCOMING_MAX_READ    4096
#define OUTGOING_MAX_READ    4096
#define MAX_CONNECTIONS      200
#define BYTES_PER_SECOND     700
#define MIN_BYTES_PER_SECOND 14400
#define MAX_BYTES_PER_SECOND 10000000

#define DEFAULT_GNUTELLAPORT 6346

GList *gl_results;
GList *gl_down_con;
GList *gl_up_con;
GList *gl_con;
GList *gl_file_db;

/* routing lists */
GList *gl_route_pings;
GList *gl_route_pongs;

GList *gl_hosts_in_cache;

struct newtella_options {
	char newtella_host[255];
	
	int hosts_in_cache, files_found, activity;
	int current_con, current_down_con, current_up_con;
	guint8 search_TTL;
	guint8 ping_TTL;
	guint32 max_bytes_per_second;
	guid gl_guid;

	/* loadable/saveable config */
	guint16 con_speed;
	guint16 newtella_port;
	guint32 local_ip;
	guint16 max_downloads, max_uploads, max_uploads_per_host, max_search_results;
	
	guint8 min_con, max_con;
	guint8 auto_connect, accept_in_con, auto_reconnect;

	gchar download_dir[255];
	GList *shared_dirs;
};

struct newtella_options *gl_options;
int gl_server, gl_read_tag;

struct host_info *gl_my_host_info;

#endif
